﻿/*
 * scraep - robust 4chan thread watcher
 * Copyright (C) 2010  ed <tripflag@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License v2
 * (version 2) as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, refer to the following URL:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace scraep
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        long autogetLast = 0;
        long autogetFreq = 15;
        Downloader dl = new Downloader();
        List<Thread> thr = new List<Thread>();

        private void _th_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Insert) _ins_Click(sender, e);
            if (e.KeyCode == Keys.Delete) _del_Click(sender, e);
            if (e.KeyCode == Keys.F5) _f5_Click(sender, e);
            if (e.KeyCode == Keys.Enter)
                if (e.Control) execLoad(false);
                else execLoad(true);
        }

        private void add(string str)
        {
            if (string.IsNullOrEmpty(str)) return;
            sta(-1, "Adding thread...");
            Application.DoEvents();

            str = str.Split('#')[0];
            Thread t = new Thread(str);
            string tid = t.identifier();
            for (int a = 0; a < thr.Count; a++)
            {
                if (thr[a].identifier() == tid)
                {
                    sta(-1, "Already added");
                    return;
                }
            }
            thr.Add(t);
            string vis = thr[thr.Count - 1].visual();
            _th.Items.Add(vis);
            sta(-1, "Added " + vis);

            _https.Checked = Program.HTTPS;
        }
        private void rem(int i)
        {
            if (i < 0) i = _th.SelectedIndex;
            string vis = thr[i].visual();
            thr.RemoveAt(i);
            _th.Items.RemoveAt(i);
            sta(-1, "Removed " + vis);
        }

        private void _ins_Click(object sender, EventArgs e)
        {
            string derp = Clipboard.GetText();
            if (derp.Length > 64) derp = "";
            add(InputBox.Derp("Thread URL (http://) or identifier (board.threadid)", derp));
        }

        private void _del_Click(object sender, EventArgs e)
        {
            rem(-1);
        }

        private void _load_Click(object sender, EventArgs e)
        {
            if (!System.IO.File.Exists("threads.txt")) return;
            thr.Clear();
            _th.Items.Clear();
            string[] so = System.IO.File.ReadAllLines("threads.txt");
            foreach (string th in so)
            {
                thr.Add(new Thread(th));
                _th.Items.Add(thr[thr.Count - 1].visual());
            }
            sta(-1, "Loaded threads");
        }

        private void _save_Click(object sender, EventArgs e)
        {
            StringBuilder so = new StringBuilder();
            foreach (Thread th in thr) so.AppendLine(th.identifier());
            System.IO.File.WriteAllText("threads.txt", so.ToString());
            sta(-1, "Saved threads");
        }

        bool f5f5f5f5f5 = false;
        private void _f5_Click(object sender, EventArgs e)
        {
            System.Threading.Thread wark = new System.Threading.Thread(new System.Threading.ThreadStart(f5));
            f5f5f5f5f5 = true;
            wark.Start();
            while (f5f5f5f5f5)
            {
                Application.DoEvents();
                System.Threading.Thread.Sleep(10);
            }
            for (int i = 0; i < thr.Count; i++)
            {
                if (thr[i].dead)
                {
                    rem(i);
                    i--;
                }
            }
        }
        void f5()
        {
            for (int i = 0; i < thr.Count; i++)
            {
                sta(i, "Looking for images...");
                if (thr[i].update())
                {
                    dl.add(thr[i].images);
                }
            }
            sta(-1, "Images remaining:");
            f5f5f5f5f5 = false;
        }

        string status;
        private void Form1_Load(object sender, EventArgs e)
        {
            if (System.IO.File.Exists(".lock"))
            {
                MessageBox.Show(
                    "There seems to be more of me running in here!" + "\r\n\r\n" +
                    "Since I temporarily save images to the \"blob\" file," + "\r\n" +
                    "only one scraep can be active.  I'm terribly sorry." + "\r\n\r\n" +
                    "If I am wrong and this really is the only running scraep," + "\r\n" +
                    "please just ignore my stupidity and continue." + "\r\n\r\n" +
                    "Have a nice day!"
                );
            }
            System.IO.File.WriteAllText(".lock", "hello");
            _load_Click(sender, e);

            Timer penis = new Timer();
            penis.Tick += new EventHandler(penis_Tick);
            penis.Interval = 100;
            penis.Start();

            Timer vagina = new Timer();
            vagina.Tick += new EventHandler(vagina_Tick);
            vagina.Interval = 5000;
            vagina.Start();

            _f5.KeyDown += new KeyEventHandler(_th_KeyDown);
            _ins.KeyDown += new KeyEventHandler(_th_KeyDown);
            _del.KeyDown += new KeyEventHandler(_th_KeyDown);
            _load.KeyDown += new KeyEventHandler(_th_KeyDown);
            _save.KeyDown += new KeyEventHandler(_th_KeyDown);
            _https.KeyDown += new KeyEventHandler(_th_KeyDown);
            _autoget.KeyDown += new KeyEventHandler(_th_KeyDown);
        }

        void penis_Tick(object sender, EventArgs e)
        {
            if (status != null)
            {
                toolStripStatusLabel1.Text = status;
                status = null;
            }
            toolStripStatusLabel2.Text = dl.remain().ToString();
        }

        void sta(int th, string str)
        {
            if (th >= 0) str = "[" + (th + 1) +
                "/" + thr.Count + "] " + str;
            status = str;
        }

        private void _th_DoubleClick(object sender, EventArgs e)
        {
            execLoad(true);
        }
        private void _th_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                int i = _th.IndexFromPoint(e.X, e.Y);
                _th.SelectedIndex = i;
                execLoad(false);
            }
        }
        private void execLoad(bool mouseleft)
        {
            int i = _th.SelectedIndex;
            if (i < 0) return;
            string[] str = _th.Items[i].ToString().Replace("/", "").Split(' ');
            string path = Application.StartupPath + "\\" + str[0] + "\\" + str[1];
            if (mouseleft)
            {
                string[] files = System.IO.Directory.GetFiles(path);
                if (files.Length <= 1) return;
                Array.Sort(files);
                System.Diagnostics.Process.Start(
                    files[0].EndsWith(".html") ?
                    files[1] : files[0]);
            }
            else
            {
                System.Diagnostics.Process.Start(path);
            }
        }

        void vagina_Tick(object sender, EventArgs e)
        {
            if (f5f5f5f5f5 ||
                dl.remain() > 0 ||
                !_autoget.Checked) return;

            long tick = S.tick();
            double diff = tick - autogetLast;
            if (diff / 60 > autogetFreq)
            {
                _f5_Click(sender, e);
                autogetLast = tick;
            }
        }

        private void _autogetc_Click(object sender, EventArgs e)
        {
            string var = InputBox.Derp("Enter frequency in minutes", _autogetc.Text);
            try
            {
                autogetFreq = Convert.ToInt32(var);
                _autogetc.Text = autogetFreq + "";
            }
            catch { }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("http://code.google.com/p/scraep/");
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            System.IO.File.Delete(".lock");
            System.Diagnostics.Process.GetCurrentProcess().Kill();
        }

        private void _https_CheckedChanged(object sender, EventArgs e)
        {
            Program.useHTTPS(_https.Checked);
        }
    }
}
